/*
hash.c - Release 0.1.0  Hash hash the key to an offset
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* The following copyright applies to the md5 algorithm */
/* Copyright (C) 1990-2, RSA Data Security, Inc. Created 1990. All
rights reserved.

RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.

These notices must be retained in any copies of any part of this
documentation and/or software.
 */

/* calculate the offset of a record */

#include <bthash.h>

off_t hash(hshhdr,key)
hashfmt *hshhdr;
unsigned char *key;
   {
   int rcdnum;
   off_t ofst;
   unsigned char *p,*q;
   unsigned char digest[32];

   /* Digests a record key and returns the digest */
   getmd5(key,hshhdr->keylen,digest);
   /* The following hashing routine is based on */
   /* Robert Sedgwick */
   /* Algorithms in C */
   /* 3rd Edition */
   /* Chapter 14 */
   rcdnum = 0;
   p = (unsigned char *) digest;
   q = (unsigned char *) p + 16;
   while (p < q)
      {
      rcdnum = ((rcdnum * 256) + *p++)
	 % hshhdr->totrcds;
      } /* for each byte in digest */
   ofst = HDRLEN + (rcdnum * hshhdr->rcdnode);
   return(ofst);
   } /* hash */
